Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/LocalImprovers/ApproximateLocalSearch.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/LocalImprovers/ApproximateLocalSearch.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/LocalImprovers/ApproximateLocalSearch.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -35,52 +35,22 @@
   [Item("ApproximateLocalSearch", "The approximate local search is described in Mateus, G., Resende, M., and Silva, R. 2011. GRASP with path-relinking for the generalized quadratic assignment problem. Journal of Heuristics 17, Springer Netherlands, pp. 527-565.")]
   [StorableClass]
-  public class ApproximateLocalSearch : SingleSuccessorOperator, IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator,
-    IWeightsAwareGQAPOperator, IDistancesAwareGQAPOperator, IInstallationCostsAwareGQAPOperator,
-    ITransportationCostsAwareGQAPOperator, IExpectedRandomQualityAwareGQAPOperator,
-    IAssignmentAwareGQAPOperator, IQualityAwareGQAPOperator, IGQAPLocalImprovementOperator,
-    IEvaluatorAwareGQAPOperator, IStochasticOperator {
+  public class ApproximateLocalSearch : SingleSuccessorOperator, IProblemInstanceAwareGQAPOperator,
+    IQualityAwareGQAPOperator, IGQAPLocalImprovementOperator, IStochasticOperator {
     public IProblem Problem { get; set; }
     public Type ProblemType {
-      get { return typeof(GeneralizedQuadraticAssignmentProblem); }
+      get { return typeof(GQAP); }
     }
 
-    public ILookupParameter<DoubleArray> DemandsParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Demands"]; }
-    }
-    public ILookupParameter<DoubleArray> CapacitiesParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Capacities"]; }
-    }
-    public ILookupParameter<DoubleMatrix> WeightsParameter {
-      get { return (ILookupParameter<DoubleMatrix>)Parameters["Weights"]; }
-    }
-    public ILookupParameter<DoubleMatrix> DistancesParameter {
-      get { return (ILookupParameter<DoubleMatrix>)Parameters["Distances"]; }
-    }
-    public ILookupParameter<DoubleMatrix> InstallationCostsParameter {
-      get { return (ILookupParameter<DoubleMatrix>)Parameters["InstallationCosts"]; }
-    }
-    public IValueLookupParameter<DoubleValue> TransportationCostsParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["TransportationCosts"]; }
-    }
-    public IValueLookupParameter<DoubleValue> ExpectedRandomQualityParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["ExpectedRandomQuality"]; }
+    public ILookupParameter<GQAPInstance> ProblemInstanceParameter {
+      get { return (ILookupParameter<GQAPInstance>)Parameters["ProblemInstance"]; }
     }
     public ILookupParameter<IntegerVector> AssignmentParameter {
       get { return (ILookupParameter<IntegerVector>)Parameters["Assignment"]; }
     }
-    public ILookupParameter<BoolValue> MaximizationParameter {
-      get { return (ILookupParameter<BoolValue>)Parameters["Maximization"]; }
-    }
     public ILookupParameter<DoubleValue> QualityParameter {
       get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-    public ILookupParameter<DoubleValue> FlowDistanceQualityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["FlowDistanceQuality"]; }
-    }
-    public ILookupParameter<DoubleValue> InstallationQualityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["InstallationQuality"]; }
-    }
-    public ILookupParameter<DoubleValue> OverbookedCapacityParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["OverbookedCapacity"]; }
+    public ILookupParameter<Evaluation> EvaluationParameter {
+      get { return (ILookupParameter<Evaluation>)Parameters["Evaluation"]; }
     }
     public IValueLookupParameter<IntValue> MaximumIterationsParameter {
@@ -102,7 +72,4 @@
       get { return (ILookupParameter<ResultCollection>)Parameters["Results"]; }
     }
-    public IValueLookupParameter<IGQAPEvaluator> EvaluatorParameter {
-      get { return (IValueLookupParameter<IGQAPEvaluator>)Parameters["Evaluator"]; }
-    }
 
     [StorableConstructor]
@@ -111,17 +78,8 @@
     public ApproximateLocalSearch()
       : base() {
-      Parameters.Add(new LookupParameter<DoubleArray>("Demands", GeneralizedQuadraticAssignmentProblem.DemandsDescription));
-      Parameters.Add(new LookupParameter<DoubleArray>("Capacities", GeneralizedQuadraticAssignmentProblem.CapacitiesDescription));
-      Parameters.Add(new LookupParameter<DoubleMatrix>("Weights", GeneralizedQuadraticAssignmentProblem.WeightsDescription));
-      Parameters.Add(new LookupParameter<DoubleMatrix>("Distances", GeneralizedQuadraticAssignmentProblem.DistancesDescription));
-      Parameters.Add(new LookupParameter<DoubleMatrix>("InstallationCosts", GeneralizedQuadraticAssignmentProblem.InstallationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("TransportationCosts", GeneralizedQuadraticAssignmentProblem.TransportationCostsDescription));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("ExpectedRandomQuality", GeneralizedQuadraticAssignmentProblem.ExpectedRandomQualityDescription));
+      Parameters.Add(new LookupParameter<GQAPInstance>("ProblemInstance", GQAP.ProblemInstanceDescription));
       Parameters.Add(new LookupParameter<IntegerVector>("Assignment", GQAPSolutionCreator.AssignmentDescription));
-      Parameters.Add(new LookupParameter<BoolValue>("Maximization", GeneralizedQuadraticAssignmentProblem.MaximizationDescription));
-      Parameters.Add(new LookupParameter<DoubleValue>("Quality", GQAPEvaluator.QualityDescription));
-      Parameters.Add(new LookupParameter<DoubleValue>("FlowDistanceQuality", GQAPEvaluator.FlowDistanceQualityDescription));
-      Parameters.Add(new LookupParameter<DoubleValue>("InstallationQuality", GQAPEvaluator.InstallationQualityDescription));
-      Parameters.Add(new LookupParameter<DoubleValue>("OverbookedCapacity", GQAPEvaluator.OverbookedCapacityDescription));
+      Parameters.Add(new LookupParameter<DoubleValue>("Quality", ""));
+      Parameters.Add(new LookupParameter<Evaluation>("Evaluation", GQAP.EvaluationDescription));
       Parameters.Add(new ValueLookupParameter<IntValue>("MaximumIterations", "The maximum number of iterations that should be performed."));
       Parameters.Add(new LookupParameter<IntValue>("EvaluatedSolutions", "The number of evaluated solution equivalents."));
@@ -130,5 +88,4 @@
       Parameters.Add(new ValueLookupParameter<PercentValue>("OneMoveProbability", "The probability for performing a 1-move, which is the opposite of performing a 2-move.", new PercentValue(.5)));
       Parameters.Add(new LookupParameter<ResultCollection>("Results", "The result collection that stores the results."));
-      Parameters.Add(new ValueLookupParameter<IGQAPEvaluator>("Evaluator", "The evaluator that is used to evaluate GQAP solutions."));
     }
 
@@ -145,27 +102,20 @@
     /// <param name="assignment">The equipment-location assignment vector.</param>
     /// <param name="quality">The solution quality.</param>
-    /// <param name="flowDistanceQuality">The quality regarding the flow-distance criteria.</param>
-    /// <param name="installationQuality">The quality regarding the installation costs.</param>
-    /// <param name="overbookedCapacity">The sum of the overbooked capacities relative to the capacity of each location.</param>
+    /// <param name="evaluation">The evaluation result of the solution.</param>
     /// <param name="maxCLS">The maximum number of candidates that should be found in each step.</param>
     /// <param name="maximumIterations">The maximum number of iterations that should be performed each time the candidate list is generated.</param>
-    /// <param name="weights">The weights matrix describes the flows between the equipments.</param>
-    /// <param name="distances">The distances matrix describes the distances between the locations at which the equipment can be installed.</param>
-    /// <param name="installationCosts">The installation costs matrix describes the installation costs of installing equipment i at location j</param>
-    /// <param name="demands">The demands vector describes the space requirements of the equipments.</param>
-    /// <param name="capacities">The capacities vector describes the available space at the locations.</param>
-    /// <param name="transportationCosts">The transportation cost represents the flow-unit per distance-unit cost factor. This value can also be set to 1 if these costs are factored into the weights matrix already.</param>
-    /// <param name="overbookedCapacityPenalty"></param>
+    /// <param name="problemInstance">The problem instance that contains the data.</param>
     /// <param name="oneMoveProbability">The probability for performing a 1-move, which is the opposite of performing a 2-move.</param>
     public static void Apply(IRandom random, IntegerVector assignment,
-      DoubleValue quality, DoubleValue flowDistanceQuality, DoubleValue installationQuality, DoubleValue overbookedCapacity,
-      IntValue maxCLS, IntValue maximumIterations,
-      DoubleMatrix weights, DoubleMatrix distances, DoubleMatrix installationCosts, DoubleArray demands, DoubleArray capacities,
-      DoubleValue transportationCosts, DoubleValue expectedRandomQuality, PercentValue oneMoveProbability,
-      IGQAPEvaluator evaluator) {
-
+      DoubleValue quality, ref Evaluation evaluation, IntValue maxCLS, IntValue maximumIterations,
+      GQAPInstance problemInstance, PercentValue oneMoveProbability) {
+      var capacities = problemInstance.Capacities;
+      var demands = problemInstance.Demands;
+      //var weights = problemInstance.Weights;
+      //var distances = problemInstance.Distances;
+      //var installationCosts = problemInstance.InstallationCosts;
       while (true) {
         int count = 0;
-        var CLS = new List<Tuple<NMove, double, double, double, double>>();
+        var CLS = new List<Tuple<NMove, double, Evaluation>>();
         double sum = 0.0;
         do {
@@ -174,13 +124,10 @@
             move = StochasticNMoveSingleMoveGenerator.GenerateExactlyN(random, assignment, 1, capacities);
           else move = StochasticNMoveSingleMoveGenerator.GenerateExactlyN(random, assignment, 2, capacities);
+          
+          var moveEval = GQAPNMoveEvaluator.Evaluate(move, assignment, evaluation, problemInstance);
+          double moveQuality = problemInstance.ToSingleObjective(moveEval);
 
-          double moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity;
-          GQAPNMoveEvaluator.Evaluate(move, assignment, weights, distances, installationCosts,
-            demands, capacities, evaluator, out moveFlowDistanceQuality, out moveInstallationQuality, out moveOverbookedCapacity);
-          double moveQuality = evaluator.GetFitness(moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity,
-            transportationCosts.Value, expectedRandomQuality.Value);
-
-          if (moveOverbookedCapacity <= 0.0 && moveQuality < 0.0) {
-            CLS.Add(Tuple.Create(move, moveQuality, moveFlowDistanceQuality, moveInstallationQuality, moveOverbookedCapacity));
+          if (moveEval.ExcessDemand <= 0.0 && moveQuality < 0.0) {
+            CLS.Add(Tuple.Create(move, moveQuality, moveEval));
             sum += 1.0 / moveQuality;
           }
@@ -202,7 +149,5 @@
           NMoveMaker.Apply(assignment, selected.Item1);
           quality.Value += selected.Item2;
-          flowDistanceQuality.Value += selected.Item3;
-          installationQuality.Value += selected.Item4;
-          overbookedCapacity.Value += selected.Item5;
+          evaluation = selected.Item3;
         }
       }
@@ -210,19 +155,14 @@
 
     public override IOperation Apply() {
+      var evaluation = EvaluationParameter.ActualValue;
       Apply(RandomParameter.ActualValue,
         AssignmentParameter.ActualValue,
         QualityParameter.ActualValue,
-        FlowDistanceQualityParameter.ActualValue,
-        InstallationQualityParameter.ActualValue,
-        OverbookedCapacityParameter.ActualValue,
+        ref evaluation,
         MaximumCandidateListSizeParameter.ActualValue,
         MaximumIterationsParameter.ActualValue,
-        WeightsParameter.ActualValue, DistancesParameter.ActualValue,
-        InstallationCostsParameter.ActualValue,
-        DemandsParameter.ActualValue, CapacitiesParameter.ActualValue,
-        TransportationCostsParameter.ActualValue,
-        ExpectedRandomQualityParameter.ActualValue,
-        OneMoveProbabilityParameter.ActualValue,
-        EvaluatorParameter.ActualValue);
+        ProblemInstanceParameter.ActualValue,
+        OneMoveProbabilityParameter.ActualValue);
+      EvaluationParameter.ActualValue = evaluation;
       return base.Apply();
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/DemandEquivalentSwapEquipmentManipluator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/DemandEquivalentSwapEquipmentManipluator.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/DemandEquivalentSwapEquipmentManipluator.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -27,5 +27,4 @@
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
-using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Random;
@@ -35,12 +34,5 @@
   [Item("DemandEquivalentSwapEquipmentManipluator", "Swaps equipment X from location A with as much equipments from location B that the demand of X is less than or equal to the demand of the swapped equipments in B.")]
   [StorableClass]
-  public class DemandEquivalentSwapEquipmentManipluator : GQAPManipulator, IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator {
-
-    public ILookupParameter<DoubleArray> DemandsParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Demands"]; }
-    }
-    public ILookupParameter<DoubleArray> CapacitiesParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Capacities"]; }
-    }
+  public class DemandEquivalentSwapEquipmentManipluator : GQAPManipulator {
 
     [StorableConstructor]
@@ -49,6 +41,4 @@
     public DemandEquivalentSwapEquipmentManipluator()
       : base() {
-      Parameters.Add(new LookupParameter<DoubleArray>("Demands", GeneralizedQuadraticAssignmentProblem.DemandsDescription));
-      Parameters.Add(new LookupParameter<DoubleArray>("Capacities", GeneralizedQuadraticAssignmentProblem.CapacitiesDescription));
     }
 
@@ -85,6 +75,6 @@
     }
 
-    protected override void Manipulate(IRandom random, IntegerVector vector) {
-      Apply(random, vector, CapacitiesParameter.ActualValue, DemandsParameter.ActualValue);
+    protected override void Manipulate(IRandom random, IntegerVector vector, GQAPInstance problemInstance) {
+      Apply(random, vector, problemInstance.Capacities, problemInstance.Demands);
     }
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/GQAPManipulator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/GQAPManipulator.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/GQAPManipulator.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -31,5 +31,5 @@
   [Item("GQAPManipulator", "A base class for operators that manipulate assignment vectors of the GeneralizedQuadraticAssignment problems.")]
   [StorableClass]
-  public abstract class GQAPManipulator : SingleSuccessorOperator, IGQAPManipulator, IAssignmentAwareGQAPOperator, IStochasticOperator {
+  public abstract class GQAPManipulator : SingleSuccessorOperator, IGQAPManipulator, IProblemInstanceAwareGQAPOperator, IStochasticOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -39,4 +39,8 @@
       get { return (ILookupParameter<IntegerVector>)Parameters["Assignment"]; }
     }
+    public ILookupParameter<GQAPInstance> ProblemInstanceParameter {
+      get { return (ILookupParameter<GQAPInstance>)Parameters["ProblemInstance"]; }
+    }
+
     public ILookupParameter<IRandom> RandomParameter {
       get { return (LookupParameter<IRandom>)Parameters["Random"]; }
@@ -49,13 +53,14 @@
       : base() {
       Parameters.Add(new LookupParameter<IntegerVector>("Assignment", GQAPSolutionCreator.AssignmentDescription));
+      Parameters.Add(new LookupParameter<GQAPInstance>("ProblemInstance", GQAP.ProblemInstanceDescription));
       Parameters.Add(new LookupParameter<IRandom>("Random", "The pseudo random number generator which should be used for stochastic manipulation operators."));
     }
 
     public sealed override IOperation Apply() {
-      Manipulate(RandomParameter.ActualValue, AssignmentParameter.ActualValue);
+      Manipulate(RandomParameter.ActualValue, AssignmentParameter.ActualValue, ProblemInstanceParameter.ActualValue);
       return base.Apply();
     }
 
-    protected abstract void Manipulate(IRandom random, IntegerVector integerVector);
+    protected abstract void Manipulate(IRandom random, IntegerVector integerVector, GQAPInstance problemInstance);
   }
 }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/MultiGQAPManipulator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/MultiGQAPManipulator.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/MultiGQAPManipulator.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -35,5 +35,6 @@
   [Item("MultiGQAPManipulator", "Randomly selects and applies one of its manipulators every time it is called.")]
   [StorableClass]
-  public class MultiGQAPManipulator : StochasticMultiBranch<IGQAPManipulator>, IGQAPManipulator {
+  public class MultiGQAPManipulator : StochasticMultiBranch<IGQAPManipulator>, IGQAPManipulator,
+    IProblemInstanceAwareGQAPOperator {
     public override bool CanChangeName {
       get { return false; }
@@ -46,4 +47,7 @@
       get { return (ILookupParameter<IntegerVector>)Parameters["Assignment"]; }
     }
+    public ILookupParameter<GQAPInstance> ProblemInstanceParameter {
+      get { return (ILookupParameter<GQAPInstance>)Parameters["ProblemInstance"]; }
+    }
 
     [StorableConstructor]
@@ -53,4 +57,6 @@
       : base() {
       Parameters.Add(new LookupParameter<IntegerVector>("Assignment", GQAPSolutionCreator.AssignmentDescription));
+      Parameters.Add(new LookupParameter<GQAPInstance>("ProblemInstance", GQAP.ProblemInstanceDescription));
+
       foreach (Type type in ApplicationManager.Manager.GetTypes(typeof(IGQAPManipulator))) {
         if (!typeof(MultiOperator<IGQAPManipulator>).IsAssignableFrom(type))
@@ -73,13 +79,21 @@
 
     private void Parameterize() {
-      foreach (var op in Operators.OfType<IGQAPManipulator>())
+      foreach (var op in Operators.OfType<IGQAPManipulator>()) {
         op.AssignmentParameter.ActualName = AssignmentParameter.Name;
-      foreach (var op in Operators.OfType<IStochasticOperator>())
+        op.AssignmentParameter.Hidden = true;
+      }
+      foreach (var op in Operators.OfType<IStochasticOperator>()) {
         op.RandomParameter.ActualName = RandomParameter.Name;
+        op.RandomParameter.Hidden = true;
+      }
+      foreach (var op in Operators.OfType<IProblemInstanceAwareGQAPOperator>()) {
+        op.ProblemInstanceParameter.ActualName = ProblemInstanceParameter.Name;
+        op.ProblemInstanceParameter.Hidden = true;
+      }
     }
 
     public override IOperation InstrumentedApply() {
       if (Operators.Count == 0) throw new InvalidOperationException(Name + ": Please add at least one manipulator to choose from.");
-      return base.Apply();
+      return base.InstrumentedApply();
     }
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/RelocateEquipmentManipluator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/RelocateEquipmentManipluator.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/RelocateEquipmentManipluator.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -27,5 +27,4 @@
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
-using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Random;
@@ -35,13 +34,6 @@
   [Item("RelocateEquipmentManipluator", "Relocates a random equipment from an overstuffed location to a random one with space or a random equipment if constraints are satisfied.")]
   [StorableClass]
-  public class RelocateEquipmentManipluator : GQAPManipulator, IDemandsAwareGQAPOperator, ICapacitiesAwareGQAPOperator {
-
-    public ILookupParameter<DoubleArray> CapacitiesParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Capacities"]; }
-    }
-    public ILookupParameter<DoubleArray> DemandsParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Demands"]; }
-    }
-
+  public class RelocateEquipmentManipluator : GQAPManipulator {
+    
     [StorableConstructor]
     protected RelocateEquipmentManipluator(bool deserializing) : base(deserializing) { }
@@ -49,6 +41,4 @@
     public RelocateEquipmentManipluator()
       : base() {
-      Parameters.Add(new LookupParameter<DoubleArray>("Demands", GeneralizedQuadraticAssignmentProblem.DemandsDescription));
-      Parameters.Add(new LookupParameter<DoubleArray>("Capacities", GeneralizedQuadraticAssignmentProblem.CapacitiesDescription));
     }
 
@@ -92,6 +82,6 @@
     }
 
-    protected override void Manipulate(IRandom random, IntegerVector vector) {
-      Apply(random, vector, CapacitiesParameter.ActualValue, DemandsParameter.ActualValue);
+    protected override void Manipulate(IRandom random, IntegerVector vector, GQAPInstance problemInstance) {
+      Apply(random, vector, problemInstance.Capacities, problemInstance.Demands);
     }
   }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/SwapEquipmentManipluator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/SwapEquipmentManipluator.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/SwapEquipmentManipluator.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -56,5 +56,5 @@
     }
 
-    protected override void Manipulate(IRandom random, IntegerVector vector) {
+    protected override void Manipulate(IRandom random, IntegerVector vector, GQAPInstance problemInstance) {
       Apply(random, vector);
     }
Index: /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/SwapLocationManipulator.cs
===================================================================
--- /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/SwapLocationManipulator.cs	(revision 15503)
+++ /branches/GeneralizedQAP/HeuristicLab.Problems.GeneralizedQuadraticAssignment/3.3/Operators/Manipulators/SwapLocationManipulator.cs	(revision 15504)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -24,7 +24,5 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Data;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
-using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -33,10 +31,6 @@
   [Item("SwapLocationManipluator", "Swaps two locations by exchanging all equipments between the locations.")]
   [StorableClass]
-  public class SwapLocationManipluator : GQAPManipulator, ICapacitiesAwareGQAPOperator {
-
-    public ILookupParameter<DoubleArray> CapacitiesParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Capacities"]; }
-    }
-
+  public class SwapLocationManipluator : GQAPManipulator {
+    
     [StorableConstructor]
     protected SwapLocationManipluator(bool deserializing) : base(deserializing) { }
@@ -44,5 +38,4 @@
     public SwapLocationManipluator()
       : base() {
-      Parameters.Add(new LookupParameter<DoubleArray>("Capacities", GeneralizedQuadraticAssignmentProblem.CapacitiesDescription));
     }
 
@@ -72,6 +65,6 @@
     }
 
-    protected override void Manipulate(IRandom random, IntegerVector vector) {
-      Apply(random, vector, CapacitiesParameter.ActualValue.Length);
+    protected override void Manipulate(IRandom random, IntegerVector vector, GQAPInstance problemInstance) {
+      Apply(random, vector, problemInstance.Capacities.Length);
     }
   }
